/************************************************************************/
/*									*/
/*	File:	tcxext.h						*/
/*
 *	THIS FREE SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
 *	WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *	OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 *	SPECIFICALLY DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR OTHER
 *	CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *	EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *	TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 *	OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *	THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 *	(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 *	USE OF THIS SOFTWARE OR ANY DERIVATIVE WORK, EVEN IF ADVISED OF THE
 *	POSSIBILITY OF SUCH DAMAGE.
 *
 *	This program is hereby placed in the public domain.  In
 *	contrast to other claims of "public domain", this means no
 *	copyright is claimed and you may do anything you like with TCX,
 *	including selling it!  As a gesture of courtesy, please retain
 *	the authorship information in the source code and documentation.
 *
 *	Contact:	Kirk Bailey (bailey@ieee.org)
 */
/*									*/
/*	External function prototype definitions for TCX.		*/
/*									*/
/************************************************************************/

/*
 *	tcx1.c
 */
extern	VOID			main();
extern	BOOL			isdecl();
extern	VOID			declglb();
extern	VOID			declloc();
extern	INT32			arraysize();
extern	struct	id_node		*decltag();
extern	struct	id_node		*enumtag();
extern	struct	id_node		*declvar();
extern	VOID			chk_align();

/*
 *	tcx2.c
 */
extern	struct	id_node		*procfunc();
extern	struct	prototype	*procarg();
extern	struct	prototype	*get_proto();

/*
 *	tcx3.c
 */
extern	VOID			comp_block();
extern	VOID			block();
extern	INT32			decl_help();
extern	INT32			decl_aggreg();
extern	VOID			ns();

/*
 *	tcx4.c
 */
extern	struct	op_node		*binaryop();
extern	struct	id_node		*greatest_type();
extern	struct	id_node		*basetype();
extern	struct	op_node		*expression();
extern	struct	op_node		*hier2();
extern	struct	op_node		*hier3();
extern	struct	op_node		*cast_it();
extern	struct	op_node		*terminal();
extern	struct	op_node		*lterminal();
extern	struct	op_node		*make_const();
extern	struct	op_node		*make_fconst();
extern	VOID			free_op_node();
extern	INT32			word();
extern	BOOL			same_type();

/*
 *	tcx5.c
 */
extern	BOOL			chkeyword();
extern	struct	id_node		*gettype();
extern	struct	id_node		*istypedef();
extern	int			getsc();
extern	struct	id_node		*abstdecl();
extern	struct	id_node		*loadtype();
extern	VOID			dodecl();
extern	BOOL			symname();
extern	char			*chksym();
extern	LABEL			getlabel();
extern	TEMP			get_dtemp();
extern	TEMP			get_temp();
extern	VOID			free_dtemp();
extern	VOID			free_temp();
extern	VOID			addswq();
extern	VOID			delswq();
extern	VOID			addswheader();
extern	VOID			delswheader();
extern	VOID			addcase();
extern	struct	op_node		*constexp();
extern	BOOL			constant();
extern	BOOL			string();
extern	int			getstring();
extern	struct	id_node		*ptrto();
extern	BOOL			isptr();
extern	BOOL			isarray();
extern	BOOL			isptrclass();
extern	VOID			modify_rslink();

/*
 *	tcx6a.c
 */
extern	VOID			expr_out();
extern	unsigned	int	expr_code();
extern	unsigned	int	bin_op();
extern	unsigned	int	assign_op();
extern	unsigned	int	do_load();
extern	unsigned	int	do_store();
extern	unsigned	int	store_indirect();
extern	unsigned	int	load_indirect();
extern	char			*real_name();
extern	VOID			padlabel();
extern	VOID			printlabel();
extern	char			*strlabel();
extern	unsigned	int	depth_max();
extern	unsigned	int	depth_extract();
extern	VOID			eqc();
extern	VOID			rev();
extern	VOID			store_temp();
extern	VOID			load_temp();
extern	VOID			addr_temp();
extern	BOOL			is_simple();
extern	BOOL			constnode();
extern	BOOL			const2node();
extern	struct	op_node		*constaddr();
extern	VOID			abs_oper();
extern	VOID			no_oper();
extern	unsigned	int	ld_zero();
extern	VOID			fp_oper();
extern	unsigned	int	fp_oplit();
extern	unsigned	int	fp_val();
extern	unsigned	int	cnvt_type();
extern	struct	id_node		*op_types();

/*
 *	tcx6b.c
 */
extern	unsigned	int	do_member();
extern	unsigned	int	bit_field();
extern	unsigned	int	do_indirect();
extern	unsigned	int	do_address();
extern	unsigned	int	do_umin();
extern	unsigned	int	do_uplus();
extern	unsigned	int	do_lnot();
extern	unsigned	int	do_bnot();
extern	unsigned	int	do_postop();
extern	unsigned	int	do_mul();
extern	unsigned	int	do_udiv();
extern	unsigned	int	do_div();
extern	INT32			bitlog2();
extern	unsigned	int	do_mod();
extern	unsigned	int	do_add();
extern	unsigned	int	do_sub();
extern	unsigned	int	do_lshift();
extern	unsigned	int	do_rshift();

/*
 *	tcx6c.c
 */
extern	unsigned	int	do_aop();
extern	unsigned	int	do_amul();
extern	unsigned	int	do_adiv();
extern	unsigned	int	do_amod();
extern	unsigned	int	audm_op();
extern	unsigned	int	do_aadd();
extern	unsigned	int	do_asub();
extern	unsigned	int	do_alshift();
extern	unsigned	int	do_arshift();
extern	unsigned	int	do_lt();
extern	unsigned	int	do_gt();
extern	unsigned	int	do_le();
extern	unsigned	int	do_ge();
extern	unsigned	int	do_ecomp();

/*
 *	tcx6d.c
 */
extern	unsigned	int	do_band();
extern	unsigned	int	do_bxor();
extern	unsigned	int	do_bor();
extern	unsigned	int	do_aband();
extern	unsigned	int	do_abxor();
extern	unsigned	int	do_abor();
extern	unsigned	int	do_bool();
extern	unsigned	int	do_land();
extern	unsigned	int	do_lor();
extern	unsigned	int	do_tern();
extern	unsigned	int	do_seq();
extern	unsigned	int	do_call();
extern	unsigned	int	do_call3();
extern	INT32			do_args();
extern	unsigned	int	do_assign();
extern	unsigned	int	do_convert();

/*
 *	tcx6e.c
 */
extern	unsigned	int	do_icall();

/*
 *	tcx7.c
 */
extern	VOID			p_flush();
extern	VOID			p_init();
extern	VOID			p_out();
extern	VOID			p_summary();

/*
 *	tcx8.c
 */
extern	VOID			getinfil();
extern	VOID			getoutfil();
extern	VOID			flushout();
extern	VOID			closeout();
extern	VOID			deleteout();
extern	VOID			getfilename();
extern	VOID			in_line();
extern	VOID			outline();
extern	VOID			mem_err();
extern	VOID			lineline();
extern	VOID			assign();
extern	VOID			error();
extern	VOID			warning();
extern	VOID			warnname();
extern	VOID			fatal();
/*lint -function(exit,fatal) */
extern	VOID			notyet();
extern	VOID			errname();
extern	INT32			f_to_l();
extern	VOID			scerr();
extern	VOID			typerr();
extern	VOID			illname();
extern	VOID			multidef();
extern	VOID			redefmem();
extern	VOID			tagerr();
extern	VOID			needpunc();
extern	VOID			keyerr();
extern	VOID			sizerr();
extern	VOID			initerr();
extern	VOID			cexperr();
extern	BOOL			match();
extern	BOOL			matchc();
extern	BOOL			nextc();
extern	BOOL			amatch();
extern	VOID			blanks();
extern	BOOL			chks();
extern	int			streq();
extern	VOID			skip();
extern	VOID			junk();
extern	BOOL			issymf();
extern	BOOL			issym();
extern	BOOL			endst();
extern	int			ch();
extern	int			nch();
extern	int			gch();
extern	VOID			putback();
extern	VOID			kill_line();
extern	char			*safecat();
extern	char			*safedec();
extern	char			*safefloat();
extern	double			l_to_f();
extern	VOID			outcomment();
extern	VOID			instruction();
extern	VOID			header();
extern	VOID			trailer();
extern	VOID			doasm();
extern	VOID			loadconstant();
extern	VOID			glblabel();
extern	VOID			segment();
extern	VOID			align();
extern	INT32			definit();

/*
 *	tcx9.c
 */
extern	VOID			dvrt_append();
extern	VOID			dvrt_copy();
extern	VOID			dvrt_free();
extern	struct	dvrt		*dvrt_get();
extern	VOID			dvrt_out();
extern	VOID			dvrt_stack();
extern	int			dvrt_status();
extern	struct	dvrt		*dvrt_unstack();
extern	VOID			dvrt_write();
extern	VOID			set_code();
extern	VOID			set_literal();
extern	VOID			set_litlit();

/*
 *	tcx10.c
 */
extern	VOID			maininit();
extern	VOID			getoptions();
extern	VOID			getspace();

/*
 *	tcx11.c
 */
extern	struct	id_node		*add_fixed();
extern	struct	id_node		*add_label();
extern	struct	id_node		*add_loc();
extern	struct	id_node		*add_lit();
extern	struct	id_node		*fixed_type();
extern	struct	id_node		*add_type();
extern	VOID			del_label();
extern	VOID			xfer_externs();
extern	VOID			mark_scope_used();
extern	VOID			mark_scope_start();
extern	VOID			enter_scope();
extern	VOID			exit_scope();
extern	struct	id_node		*find_tag();
extern	VOID			free_level();
extern	VOID			free_plist();
extern	struct	id_node		*get_node();
extern	VOID			inittypes();
extern	struct	id_node		*lookup_node();
extern	int			new_name_space();
extern	VOID			scan_ripup();
extern	VOID			scan_global();
extern	VOID			scan_literals();
extern	VOID			emit_literals();
extern	VOID			del_literals();
